//Video Wand 2005 By Chris Kairalla
//Video tracking code by Dan O'Sullivan
//ITP Intro to Computational Media Fall 2005

import processing.serial.*; 
import processing.video.*;

Capture video;

// These variables are for quick modification
int portNum = 2;    //serial port number
int amount = 50;  //max amount of sparks
int lineAmount = 10;  //max amount of drawn lines
int ballMax = 25;  //max size of sparkball

Serial lightPen;  // The serial port
float targetRed = 255.0; //set some numbers for the target you are chasing
float targetGreen = 255.0;
float targetBlue = 255.0;
float dirX = 0.0;  //direction and velocity of points
float dirY = 0.0;

int xFound = 0; // tracker coordinates
int yFound = 0;
int xFound2 = 0; // throwing coordinates
int yFound2 = 0;
int pxFound = 0;  //previous coordinates
int pyFound = 0;
int ppxFound = 0;  //previous coordinates
int ppyFound = 0;
int k = 0;
int penColor = 3;
int ballSize = 0;  
int linesDrawn = 0;
int release = 0;
int switcher1 =0;  //triggers throwing of ball
int ballOff = 0;  //ball goes away after 2 seconds;
int counter2=0;
String inString;  //data from serial port
char inChar;

lineDraw[] lines = new lineDraw[lineAmount];
spark[] wandSpark = new spark[amount];
sparkExplode[] sparkExplode1 = new sparkExplode[amount];
sparkBall[] ball1 = new sparkBall[amount];

boolean startTrue= true;
boolean stopCounter = false;
boolean stopCounterBall = false;
boolean penDown = false;
boolean waitOne = false;  //This is a hack for getting the right serial value
boolean explode = false;

boolean lotr = false;    //Lord of the Rings Mode!!

int sparkR = 255; //red value for spark
int sparkG = 0;  //green value for spark
int sparkB = 0;  //blue value for spark
int counter = 0; 
int counterBall = 0;

void setup(){
  video = new Capture(this, 320, 240, 15); //initiate the video, resolution and frame rate
  lightPen = new Serial(this, Serial.list()[portNum], 9600);
  size (640,480);
  framerate(30);
  noStroke();
  smooth();
  for (int i=0; i < amount; i++){
    wandSpark[i] = new spark();
  }
  for (int i=0; i < amount; i++){
    ball1[i] = new sparkBall();
  }
  for (int i=0; i < amount; i++){
    sparkExplode1[i] = new sparkExplode();
  }
  for (int i=0; i < lineAmount; i++){
    lines[i] = new lineDraw();
  }
}
// ************ MAIN DRAW ROUTINE  ************

void draw(){
  if (lotr==false){
    vidCompute(); //tracks light and flips video
    offset(); //This staggers the sparks so that they don't all come out at once.
    offsetBall(); //This staggers the ball.
    throwCompute();
    if (penColor > 2){    
      drawSparkBall2 (xFound2, yFound2); //This draws the spark ball thrown.  
      drawSparkBall(xFound, yFound); //This draws the spark ball on pen.
      if (explode){
        drawSparksExplode(xFound2, yFound2);
      }
    }
    drawSparks(xFound, yFound);//This draws the spark objects.
    drawLines();
    palette(); //draw color palette at bottom of screen. 50% opacity.
    colorcheck(xFound, yFound); //is the user choosing a new color?
    sendColor(); //Change pen color
    ppxFound = pxFound;
    ppyFound = pyFound;
    pxFound = xFound;
    pyFound = yFound;
  }


  if (lotr) {
    background(0);
    vidComputeLotr();
  }
}






//Below are all the functions.
//***********************************************

void keyPressed(){
  //this erases the lines
  for (int i=0; i < linesDrawn; i++){
    lines[i].drawIt(penDown, true, xFound, yFound, pxFound, pyFound, color(sparkR, sparkG, sparkB));
  }
  linesDrawn = 0;
  if (key == 'l' || key == 'l'){
    lotr =! lotr;
  }
}

//***********************************************

void captureEvent(Capture camera){ 
  camera.read(); 
} 

void vidCompute(){
  float worldRecord = 1000.0; //intialize the worldrecord
  if (penColor == 0){
    targetRed = 255;
    targetGreen = 245;
    targetBlue = 38;
  }
  if (penColor == 1){
    targetRed = 100;
    targetGreen = 255;
    targetBlue = 245;
  }
  if (penColor == 2){
    targetRed = 65;
    targetGreen = 245;
    targetBlue = 255;
  }
  if (penColor > 2){
    targetRed = 255;
    targetGreen = 255;
    targetBlue = 255;
  }
  for(int j=0; j<video.height; j=j+1) { //for each row
    for(int i=0; i<video.width; i=i+1) { //for each column
      //get the color of this pixels
      //find pixel in linear array using formula: pos = row*rowWidth+column
      color pix = video.pixels[j*video.width+i]; 
      //find the difference
      float diff = abs(targetRed - red(pix)) + abs(targetGreen - green(pix)) + abs(targetBlue - blue(pix));
      int flip = abs (i-320);
      if (diff< worldRecord){ // if this is closest to our target color
        worldRecord = diff;
        yFound = j; //mark the spot for drawing it later
        xFound = flip;
      }
    }
  }
  scale(-2.0, 2.0);
  image(video,-320,0); 
  scale(-1.0, 1.0);
}

//***********************************************


void offset(){
  if (stopCounter == false){
    counter++;
    if (counter > amount-2){
      stopCounter=true;
    }
  }
}

//***********************************************

void offsetBall(){
  if (penDown == true){
    if (stopCounterBall == false){
      counterBall++;
      if (counterBall > amount-2){
        stopCounterBall=true;
      }
    }
  }
}

//***********************************************

void throwCompute(){
  if (switcher1 == 1){
    dirX = (xFound-ppxFound)/2;
    dirY = (yFound-ppyFound)/2;
    xFound2 = xFound;
    yFound2 = yFound;
    ballOff = 0;
  }
  if (switcher1==2){
    xFound2 = (xFound2 + int(dirX));
    yFound2 = (yFound2 + int(dirY));
    ballOff ++;
    if (ballOff > 60){
      explode = true;
    }
    if (xFound2 < 15 || xFound2 > width/2-15 || yFound2 < 15 || yFound2> height/2-15){
      explode = true;
    }
  }
}   

//***********************************************


void serialEvent(Serial p){
  inChar = char(lightPen.read()); 
  if (waitOne == true){
    if (inChar == '1'){
      release++;
      switcher1 = 1;
      if (release > 2){
        release = 2;
      } 
      penDown = true;
      waitOne = false;
      if (release == 1 && penColor < 3){
        linesDrawn ++;
        if (linesDrawn > lineAmount){
          linesDrawn = lineAmount;
        }
      }
    } 
    else {
      if (switcher1 == 1){
        switcher1 =2;
      }
      penDown = false;
      for (int i=0; i < linesDrawn; i++){
        lines[i].penUp();
      }
      waitOne = false;
      release = 0;
    }
    //  println (linesDrawn);
    //  println(inChar);  //tests the button state
  } 
  if (inChar == 'A') { 
    waitOne=true;
  } 
}
//*************************************************
void drawSparkBall(int _xFound, int _yFound){
  if (stopCounterBall == false){
    ball1[counterBall].switchIt(startTrue);
  }
  if (penDown == true){
    ballSize = ballSize +2;
    if (ballSize > ballMax){
      ballSize = ballMax;
    }
  } 
  else {
    ballSize = 0;
  }
  for (int i=0; i < counterBall; i++){
    ball1[i].drawIt(sparkR,sparkG,sparkB, xFound , yFound, ballSize, penDown, explode);
  }

}

//*************************************************
void drawSparkBall2 (int _xFound2, int _yFound2){
  if (stopCounterBall == false){
    ball1[counterBall].switchIt(startTrue);
  }
  if (penDown == false &&  switcher1 == 2){
    ballSize = ballMax;
    for (int i=0; i < counterBall; i++){
      ball1[i].drawIt(sparkR,sparkG,sparkB, _xFound2 , _yFound2 , ballSize, true, explode);
    }
  }
} 


//***********************************************

void drawSparks(int _xFound, int _yFound){
  if (stopCounter == false){
    wandSpark[counter].switchIt(startTrue);
  }
  for (int i=0; i < amount; i++){

    wandSpark[i].drawIt(sparkR,sparkG,sparkB,_xFound,_yFound, penDown);
  }

}



//***********************************************

void drawSparksExplode(int _xFound2,int _yFound2) {
  counter2++;
  for (int i=0; i < amount; i++){
    sparkExplode1[i].drawIt(sparkR,sparkG,sparkB,_xFound2,_yFound2, penDown);
  }
  if (counter2 > 10){
    counter2 = 0;
    switcher1 = 0;
    ballOff = 0;
    explode = false;

  }
}
//***********************************************


void drawLines(){
  for (int i=0; i < linesDrawn; i++){
    lines[i].drawIt(penDown, false, xFound, yFound, pxFound, pyFound, color(sparkR, sparkG, sparkB, 128));
  }
}
void palette(){
  noStroke();
  fill(255,255,255,128); //white rec color
  rect(0,height/2-20,width/8,20); //white rectangle
  fill(255,0,0,128); //red rec color
  rect(width/8,height/2-20,width/8,20); //red rectangle
  fill(0,255,0,128); //green rec color
  rect(width/4,height/2-20,width/8,20); //green rectangle
  fill(0,0,255,128); //blue rec color
  rect(width/4 + width/8,height/2-20,width/8,20); //blue rectangle
}

//***********************************************
void colorcheck(int _xFound, int _yFound){
  if (penColor == 3){
    sparkR = 255;
    sparkG = 255;
    sparkB = 255;
  }
  if (_yFound > height/2-20){
    if (_xFound < width/8){
      sparkR = 255;
      sparkG = 255;
      sparkB = 255;
      penColor = 3;
    }
    if (_xFound >= width/8 && _xFound < width/4){
      sparkR = 255;
      sparkG = 128;
      sparkB = 128;
      penColor = 0;
    }
    if (_xFound >= width/4 && _xFound < width/4 + width/8){
      sparkR = 128;
      sparkG = 255;
      sparkB = 128;
      penColor = 1;
    }
    if (_xFound > width/4 + width/8){
      sparkR = 128;
      sparkG = 128;
      sparkB = 255;
      penColor = 2;
    }
  }
}

//***********************************************

void sendColor(){
  if (penColor == 0){
    lightPen.write("0");
  }
  if (penColor == 1){
    lightPen.write("1");
  }
  if (penColor == 2){
    lightPen.write("2");
  }
  if (penColor > 2){
    lightPen.write("3");
  }
}
//***********************************************
void mousePressed(){
  //This allows me to check the color of a pixel 
  int colorFlip = abs(mouseX-width);
  color pix = video.pixels[mouseY*video.width+colorFlip];
  targetRed = red(pix); //get the color of the pixel they clicked on
  targetGreen = green(pix);
  targetBlue = blue(pix);
  println(targetRed);
  println(targetGreen);
  println(targetBlue);


}

//************************************************************\\

void vidComputeLotr(){
  float worldRecord = 1000.0; //intialize the worldrecord
  if (penColor == 0){
    targetRed = 255;
    targetGreen = 245;
    targetBlue = 38;
  }
  if (penColor == 1){
    targetRed = 100;
    targetGreen = 255;
    targetBlue = 245;
  }
  if (penColor == 2){
    targetRed = 65;
    targetGreen = 245;
    targetBlue = 255;
  }
  if (penColor > 2){
    targetRed = 255;
    targetGreen = 255;
    targetBlue = 255;
  }
  for(int j=0; j<video.height; j=j+1) { //for each row
    for(int i=0; i<video.width; i=i+1) { //for each column
      //get the color of this pixels
      //find pixel in linear array using formula: pos = row*rowWidth+column
      color pix = video.pixels[j*video.width+i]; 
      //find the difference
      float diff = abs(targetRed - red(pix)) + abs(targetGreen - green(pix)) + abs(targetBlue - blue(pix));
      int flip = abs (i-320);
      if (diff< worldRecord){ // if this is closest to our target color
        worldRecord = diff;
        yFound = j; //mark the spot for drawing it later
        xFound = i;
      }
    }
  }
  scale(-2.0, 2.0);
  image(video,-320,0); 
  for(int j=0; j<yFound+3; j=j+int(random(3,9))) { //for each row
    for(int i=0; i<video.width; i=i+int(random(3,9))) { //for each column
      color c = video.pixels[j*video.width+i];
      float lineWeight = dist(i, j, xFound, yFound)/20;
      float colorWeight = dist(i, j, xFound, yFound)/2;
      switch(penColor) { 
      case 0: 
        stroke (red(c)-colorWeight+50, green(c)-colorWeight, blue(c)-colorWeight, 128);  
        break; 
      case 1: 
        stroke (red(c)-colorWeight, green(c)-colorWeight+50, blue(c)-colorWeight, 128);
        break; 
      case 2: 
        stroke (red(c)-colorWeight, green(c)-colorWeight, blue(c)-colorWeight+50, 128);
        break; 
      case 3: 
        stroke (red(c)+30-colorWeight, green(c)+30-colorWeight, blue(c)+30-colorWeight, 128);  
        break; 
      } 
      if (lineWeight < 2){
        lineWeight = 2;
      }
      strokeWeight(lineWeight);
      // noSmooth();
      if (i < xFound){
        dirX = ((xFound-i)*-1)/3;
      } 
      else {
        dirX = (i-xFound)/3;
      }
      if (j < yFound){
        dirY = ((yFound-j)*-1)/3;
      } 
      else {
        dirY = (j-yFound)/3;
      }
      line (i-320,j,dirX+i-320, dirY+j);
    }
  }

  for(int j=video.height-1; j>yFound-3; j=j-int(random(3,9))) { //for each row
    for(int i=0; i<video.width; i=i+int(random(3,9))) { //for each column
      color c = video.pixels[j*video.width+i];
      float colorWeight = dist(i, j, xFound, yFound)/2;
      switch(penColor) { 
      case 0: 
        stroke (red(c)-colorWeight+50, green(c)-colorWeight, blue(c)-colorWeight, 128);  
        break; 
      case 1: 
        stroke (red(c)-colorWeight, green(c)-colorWeight+50, blue(c)-colorWeight, 128);
        break; 
      case 2: 
        stroke (red(c)-colorWeight, green(c)-colorWeight, blue(c)-colorWeight+50, 128);
        break; 
      case 3: 
        stroke (red(c)+30-colorWeight, green(c)+30-colorWeight, blue(c)+30-colorWeight, 128);  
        break; 
      }
      float lineWeight = dist(i, j, xFound, yFound)/10;
      if (lineWeight < 2){
        lineWeight = 2;
      }
      strokeWeight(lineWeight);
      // noSmooth();
      if (i < xFound){
        dirX = ((xFound-i)*-1)/3;
      } 
      else {
        dirX = (i-xFound)/3;
      }
      if (j < yFound){
        dirY = ((yFound-j)*-1)/3;
      } 
      else {
        dirY = (j-yFound)/3;
      }
      line (i-320,j,dirX+i-320, dirY+j);
    }
  }

  scale(1.0, 1.0);
}
